#include<string.h>
#include<View.h>
#include "BeatMap.h"

#pragma export on
void  Filter(void *G);
int WhatPlugIn(void);
void RequestInfo(void *G);
#pragma export reset

uchar *Source;
ulong lx,ly;
ulong rb;
void (*SetProgress)(int);

uchar FloatToChar(float a)
{
	if(a<0) a=-a;
	unsigned char b = (unsigned char) a;
	if( (a-b) > 0.5 )	return b+1;
	return b;
}

long FilterThread(void *a)
{
	ulong y,x;
	uchar *Where;
	y=0;
	while(y<ly)
	{
	 Where		=	Source + y*rb;
	 for(x=0;x<lx;x++)
	 {
		Where[2]=255-Where[2];
		Where[1]=255-Where[1];
		Where[0]=255-Where[0];

		Where+=4;
	 }
	 y++;
	}
	return 1;
}

void RequestInfo(void *G)
{
	Current_State * CS = (Current_State *)G;
	strcpy(CS->Author,"CHAUT Pierre-Emmanuel");
	strcpy(CS->Name,"Invert Image");
	strcpy(CS->Desc,"Invert R, G, B componments");
	CS->Version = 1.0;
	CS->UpdatePlugInInfo = 1;

}


void Filter(void *G)
{
	int x,y;

	Current_State * CS = (Current_State *)G;
	BBitmap *CB	=	(BBitmap *)CS->CurrentBitmap;
	SetProgress	=	(void (*)(int))CS->ProgressFunction;
	BRect Bound	=	CB->Bounds();
	uchar *Bit	=	(uchar *)CB->Bits();
	rb			=	CB->BytesPerRow();
	Source		=	Bit;
	lx			=	Bound.right+1;
	ly			=	Bound.bottom+1;
	
	strcpy(CS->Author,"CHAUT Pierre-Emmanuel");
	strcpy(CS->Name,"Invert Image");
	strcpy(CS->Desc,"Invert R,G,B componments");
	CS->Version = 1.0;
	CS->UpdatePlugInInfo = 1;
	if(CS->UsingCommandLine)
	{
			CS->HasError = 1;
			strcpy(CS->Error,"No parameter accepted !");
			return;
	}	

	FilterThread(NULL);
}


int WhatPlugIn(void)
{
	return PLUGINS_FILTER;
}