#include<string.h>
#include<File.h>
#include "BeatWindow.h"
#include "PlugIns.h"

#pragma export on
void ReadFile(void *G,char *Name,void *BM,void *BW);
int IsMyType(void *G);
int WhatPlugIn(void);
void RequestInfo(void *G);
#pragma export reset


int WhatPlugIn(void)
{
	return PLUGINS_LOADER;
}

int IsMyType(void *G)
{
	IsMyType_Struct *MTS = (IsMyType_Struct *)G;
	unsigned short *FB=(unsigned short *)MTS->FirstBytes,tmp;
	write_16_swap((short *)&tmp, FB[8]); 
	if(tmp!=24)			// No other mode than 24 bytes supported
		return 0;
	else
	{
		unsigned long x,y;
		uchar r;	

		x	=	MTS->FirstBytes[12];
		x	+=	256*MTS->FirstBytes[13];
		y	=	MTS->FirstBytes[14];
		y	+=	256*MTS->FirstBytes[15];
		MTS->R.left=0;
		MTS->R.top=0;
		MTS->R.right=x-1;
		MTS->R.bottom=y-1;
		
		MTS->C		=	B_RGB_32_BIT;
		return 1;
	}
	
}


void RequestInfo(void *G)
{
	Current_State * CS = (Current_State *)G;
	strcpy(CS->Author,"CHAUT Pierre-Emmanuel");
	strcpy(CS->Name,"Load TGA 24");
	strcpy(CS->Desc,"Now you can drop a TGA 24 bits image file onto BetMap");
	CS->Version = 1.0;
	CS->UpdatePlugInInfo = 1;

}

void ReadFile(void *G,char *Name,void *BMp,void *BWp)
{
	BFile *F=(BFile *)G;
	BeatMap *BM		=	(BeatMap *)BMp;
	BeatWindow *BW	=	(BeatWindow *)BWp;
		
	ulong rb 		=	BM->BytesPerRow(); 
	BRect R			=	BM->Bounds();
	unsigned long x =	R.right+1;
	unsigned long y	=	R.bottom+1;
	
	uchar *C=new uchar[x*y*3];
	unsigned long v=x*y*3;
	unsigned long u,r;
	uchar Buffer[8];
	
	if(F->Open(B_READ_WRITE)!=B_NO_ERROR)
		return;
	F->Read(&Buffer,18);

	F->Read(C,v);
	for(u=0;u<v;u+=3)
	{
		r=C[u];
		C[u]=C[u+2];
		C[u+2]=r;
	}
	for(u=0;u<y;u++)
		BM->SetBits((void *)&C[u*x*3],x*3,(y-u-1)*rb,B_RGB_32_BIT);
	delete C;
	F->Close();
}
